package de.joethei.hs.java2.praktikum1;

import java.util.Arrays;
import java.util.logging.Logger;

public class GrosseZahl {

    private static Logger logger = Logger.getLogger(GrosseZahl.class.getName());

    private int ziffern[];

    public GrosseZahl(String d) {
        boolean korrekteEingabe = true;
        for (int i = 0; i < d.length(); i++) {
            if (Integer.parseInt(String.valueOf(d.charAt(i))) < 0 || Integer.parseInt(String.valueOf(d.charAt(i))) > 9) {
                korrekteEingabe = false;
            }
        }
        if (korrekteEingabe) {
            ziffern = new int[d.length()];
            for (int w = 0; w < d.length(); w++) {
                ziffern[w] = Integer.parseInt(String.valueOf(d.charAt(w)));
            }

        } else {
            System.out.println("Incorrect Input!");
        }
    }

    public GrosseZahl(int i) {
        String intZahl = Integer.toString(i);
        ziffern = new int[intZahl.length()];
        for (int w = 0; w < intZahl.length(); w++) {
            ziffern[w] = Integer.parseInt(String.valueOf(intZahl.charAt(w)));
        }
    }

    private GrosseZahl(int[] ziffern) {
        this.ziffern = ziffern;
    }

    public String toString() {
        StringBuilder rueckgabe = new StringBuilder();
        for (int ziffer : ziffern) {
            rueckgabe.append(Integer.toString(ziffer));
        }
        return rueckgabe.toString();
    }

    public boolean less(GrosseZahl b) {
        if(this.equals(b)) return false;
        if (this.ziffern.length < b.ziffern.length) return true;
        if (this.ziffern.length > b.ziffern.length) return false;

        for (int i = this.ziffern.length -1; i >= 0; i--) {
            if (this.ziffern[i] > b.ziffern[i]) return false;
        }
        return true;
    }

    public GrosseZahl add(GrosseZahl b) {
        GrosseZahl big = this.less(b) ? b : this;
        GrosseZahl small = this.less(b) ? this : b;

        int[] array;
        if(big.ziffern.length != small.ziffern.length) {
            int diff = big.ziffern.length - small.ziffern.length;
            array = new int[small.ziffern.length + diff];
            Arrays.fill(array, 0);

        }else array = new int[small.ziffern.length];

        for(int i = small.ziffern.length - 1; i >= 0; i--) {
            array[array.length - i - 1] = small.ziffern[small.ziffern.length - i - 1];
        }

        int over = 0;
        for(int i = array.length -1; i >= 0; i--) {
            int tmp = array[i] + big.ziffern[i] + over;
            over = 0;
            if(tmp > 9) {
                over = tmp - 9;
                array[i] = 0;
            }else {
                array[i] = tmp;
            }
        }

        return new GrosseZahl(array);
    }

    public GrosseZahl sub(GrosseZahl b) {


        return null;
    }

    public GrosseZahl mult(GrosseZahl b) {

        return null;
    }

    /*
    public GrosseZahl ggT(GrosseZahl b) {
        int IntZahl = 0;
        for (int aZahl : Zahl) {
            IntZahl *= 10;
            IntZahl += aZahl;
        }
        if (IntZahl == b.toInt()) {
            return b;
        } else if (this.less(b)) {
            GrosseZahl c = new GrosseZahl(b.toInt() - IntZahl);
            return this.ggT(c);
        } else {
            GrosseZahl c = new GrosseZahl(Math.abs(IntZahl - b.toInt()));
            return c.ggT(b);
        }
    }
    */

    public GrosseZahl ggT(GrosseZahl b) {
        if(this.equals(b)) return this;
        if(this.less(b)) return this.ggT(b.sub(this));
        else return this.sub(b).ggT(b);
    }

    @Override
    public boolean equals(Object o) {
        if(o instanceof GrosseZahl) {
            GrosseZahl tmp = (GrosseZahl) o;
            if(tmp.ziffern.length == this.ziffern.length) {
                for(int i = this.ziffern.length - 1; i >= 0; i--) {
                    if(tmp.ziffern[i] != this.ziffern[i]) return false;
                }
                return true;
            }else return false;
        }
        return false;
    }
}
